"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MssqlDestination = void 0;
var database_destination_1 = require("./base/database-destination");
var MssqlDestination = /** @class */ (function (_super) {
    __extends(MssqlDestination, _super);
    function MssqlDestination(config) {
        var _this = _super.call(this, config) || this;
        _this.connection = config.connection;
        return _this;
    }
    MssqlDestination.prototype.loadBatch = function (data) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var sql, _b, pool, db, query, table, columns, _i, data_1, x, args, ii, transaction, err_1;
            var _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!((_a = this.connection.driver) !== null && _a !== void 0)) return [3 /*break*/, 1];
                        _b = _a;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('mssql')); })];
                    case 2:
                        _b = _d.sent();
                        _d.label = 3;
                    case 3:
                        sql = _b;
                        pool = new sql.ConnectionPool(__assign({}, this.connection));
                        return [4 /*yield*/, pool.connect()];
                    case 4:
                        db = _d.sent();
                        return [4 /*yield*/, db.request().query("SELECT TOP(0) * FROM " + this.table)];
                    case 5:
                        query = _d.sent();
                        table = query.recordset.toTable(this.table);
                        columns = table.columns.map(function (x) { return x.name; });
                        for (_i = 0, data_1 = data; _i < data_1.length; _i++) {
                            x = data_1[_i];
                            args = [];
                            for (ii = 0; ii < columns.length; ii++) {
                                args.push(x[columns[ii]]);
                            }
                            (_c = table.rows).add.apply(_c, args);
                        }
                        transaction = new sql.Transaction(db);
                        _d.label = 6;
                    case 6:
                        _d.trys.push([6, 10, , 14]);
                        return [4 /*yield*/, transaction.begin()];
                    case 7:
                        _d.sent();
                        return [4 /*yield*/, transaction.request().bulk(table)];
                    case 8:
                        _d.sent();
                        return [4 /*yield*/, transaction.commit()];
                    case 9:
                        _d.sent();
                        return [3 /*break*/, 14];
                    case 10:
                        err_1 = _d.sent();
                        if (!!transaction._aborted) return [3 /*break*/, 12];
                        return [4 /*yield*/, transaction.rollback()];
                    case 11:
                        _d.sent();
                        _d.label = 12;
                    case 12: return [4 /*yield*/, pool.close()];
                    case 13:
                        _d.sent();
                        throw err_1;
                    case 14: return [4 /*yield*/, pool.close()];
                    case 15:
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return MssqlDestination;
}(database_destination_1.DatabaseDestination));
exports.MssqlDestination = MssqlDestination;
