import { AxiosRequestConfig } from 'axios';
import { AuthorizationRequest, IHttpDestinationConfig } from '../types';
import { Destination } from './base/destination';
export declare class HttpDestination extends Destination {
    protected request: AxiosRequestConfig;
    protected authorizationRequest?: AuthorizationRequest;
    constructor(config: IHttpDestinationConfig);
    loadBatch(data: any[]): Promise<void>;
}
