import { IPostgresDestinationConfig, IPostgresDbConnection } from '../types';
import { DatabaseDestination } from './base/database-destination';
export declare class PostgresDestination extends DatabaseDestination {
    protected connection: IPostgresDbConnection;
    protected upsertConstraints: string[] | undefined;
    constructor(config: IPostgresDestinationConfig);
    loadBatch(data: any[]): Promise<void>;
}
