import { IDelimitedProcessorConfig, processStream } from '../types';
import { DirectoryProcessor } from './base/directory-processor';
export declare class DelimitedProcessor extends DirectoryProcessor {
    protected rowSeparator: string;
    protected hasHeader: boolean;
    protected delimiter?: string;
    protected qualifier?: string;
    protected encoding?: string;
    constructor(config: IDelimitedProcessorConfig);
    process(processStream: processStream): Promise<void>;
}
